﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.Device
{
    public class VariableMonitorAttribute : Attribute
    {
        /// <summary>
        /// 变量描述
        /// </summary>
        /// <param name="Notes">描述</param>
        /// <param name="PLCAddress">PLC 地址</param>
        /// <param name="ModbusTcpAddress">Modbus TCP 地址</param>
        public VariableMonitorAttribute(string Notes, string PLCAddress = "", string ModbusTcpAddress = "")
        {
            this.PLCAddress = PLCAddress;
            this.ModbusTcpAddress = ModbusTcpAddress;
            this.Notes = Notes;
        }

        /// <summary>
        /// PLC 地址
        /// </summary>
        public string PLCAddress { get; set; }

        /// <summary>
        /// Modbus TCP 地址
        /// </summary>
        public string ModbusTcpAddress { get; set; }

        /// <summary>
        /// 描述
        /// </summary>
        public string Notes { get; set; }
    }
}
