﻿using BPASmartClient.Device;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.MorkS
{
    public class Alarm : IAlarm
    {
        /// <summary>
        /// 煮面机左侧低温报警
        /// PLC ---> M550.0
        /// ModbusTcp --> 1570
        /// </summary>
        [Alarm("煮面机左侧低温报警")]
        public bool MachineLeftLowTemperature { get; set; }

        /// <summary>
        /// 煮面机左侧低温报警
        /// PLC ---> M550.1
        /// ModbusTcp --> 1571
        /// </summary>
        [Alarm("煮面机右侧低温报警")]
        public bool MachineRightLowTemperature { get; set; }

        /// <summary>
        /// 供碗1缺碗
        /// PLC ---> M550.2
        /// ModbusTcp --> 1572
        /// </summary>
        [Alarm("供碗1缺碗")]
        public bool Supply1_LossBowl { get; set; }

        /// <summary>
        /// 供碗2缺碗
        /// PLC ---> M550.3
        /// ModbusTcp --> 1573
        /// </summary>
        [Alarm("供碗2缺碗")]
        public bool Supply2_LossBowl { get; set; }

        /// <summary>
        /// 供碗1出碗检测异常
        /// PLC ---> M550.4
        /// ModbusTcp --> 1574
        /// </summary>
        [Alarm("供碗1出碗检测异常")]
        public bool Supply1_ErrorOutBowl { get; set; }

        /// <summary>
        /// 供碗2出碗检测异常
        /// PLC ---> M550.5
        /// ModbusTcp --> 1575
        /// </summary>
        [Alarm("供碗2出碗检测异常")]
        public bool Supply2_ErrorOutBowl { get; set; }

        /// <summary>
        /// 推碗气缸故障
        /// PLC ---> M550.6
        /// ModbusTcp --> 1576
        /// </summary>
        [Alarm("推碗气缸故障")]
        public bool PushBowlCylinderError { get; set; }

        /// <summary>
        /// 煮面机通讯异常
        /// PLC ---> M550.7
        /// ModbusTcp --> 1577
        /// </summary>
        [Alarm("煮面机通讯异常")]
        public bool NoodleMacCommunicateError { get; set; }

        /// <summary>
        /// 配料机通讯异常
        /// PLC ---> M551.0
        /// ModbusTcp --> 1580
        /// </summary>
        [Alarm("配料机通讯异常")]
        public bool DosingMacCommunicateError { get; set; }

        /// <summary>
        /// 机器人通讯异常
        /// PLC ---> M551.1
        /// ModbusTcp --> 1581
        /// </summary>
        [Alarm("机器人通讯异常")]
        public bool RobotMacCommunicateError { get; set; }

        /// <summary>
        /// 机器人初始化失败
        /// PLC ---> M551.3
        /// ModbusTcp --> 1583
        /// </summary>
        [Alarm("机器人初始化失败")]
        public bool RobotInitError { get; set; }

        /// <summary>
        /// 机器人急停
        /// PLC ---> M551.4
        /// ModbusTcp --> 1584
        /// </summary>
        [Alarm("机器人急停")]
        public bool RobotUrgentStop { get; set; }

        /// <summary>
        /// 机器人不在远程模式
        /// PLC ---> M551.5
        /// ModbusTcp --> 1585
        /// </summary>
        [Alarm("机器人不在远程模式")]
        public bool RobotNotInRemoteMode { get; set; }

        /// <summary>
        /// 机器人伺服未就绪
        /// PLC ---> M551.6
        /// ModbusTcp --> 1586
        /// </summary>
        [Alarm("机器人伺服未就绪")]
        public bool RobotNotInReady { get; set; }

        /// <summary>
        /// 机器人本体异常
        /// PLC ---> M551.7
        /// ModbusTcp --> 1587
        /// </summary>
        [Alarm("机器人本体异常")]
        public bool RobotSelfInException { get; set; }
    }
}
